"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const TextField_1 = __importDefault(require("@material-ui/core/TextField"));
const react_1 = __importStar(require("react"));
const Autocomplete_1 = __importDefault(require("@material-ui/lab/Autocomplete"));
exports.Dropdown = (inputProps) => {
    const { onSelectChange, options, dimension, selectedValue, disableClear } = inputProps;
    if (!options || !options.length) {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
    const currentlySelectedOption = getCurrentlySelectedOption(options, selectedValue);
    const selectedOptionName = getOptionName(currentlySelectedOption);
    const [inputValue, setInputValue] = react_1.default.useState(selectedOptionName);
    react_1.useEffect(() => {
        if (!selectedValue) {
            setInputValue('');
        }
    }, [selectedValue]);
    return (react_1.default.createElement("div", { "data-testid": "DROPDOWN", style: { paddingTop: 10 } },
        react_1.default.createElement(Autocomplete_1.default, { "data-testid": dimension, fullWidth: true, disablePortal: true, disableClearable: !!disableClear, value: selectedValue, inputValue: inputValue, onBlur: () => setInputValue(selectedOptionName), onInputChange: (event, newInputValue) => {
                event && setInputValue(safeToString(newInputValue));
            }, onChange: (event, selectedOption) => {
                if (!selectedOption) {
                    if (canClearValue(disableClear, event)) {
                        setInputValue('');
                        onSelectChange(null, dimension);
                    }
                }
                else {
                    setInputValue(getOptionName(selectedOption));
                    onSelectChange(selectedOption.value, dimension);
                }
            }, options: options, getOptionLabel: (option) => getOptionName(option), renderInput: (params) => (react_1.default.createElement(TextField_1.default, Object.assign({}, params, { label: dimension, variant: "outlined" }))) })));
};
function canClearValue(disableClear, event) {
    var _a;
    return !disableClear && ((_a = event) === null || _a === void 0 ? void 0 : _a.type) === 'click';
}
function safeToString(value) {
    return (value || '').toString();
}
function getOptionName(option) {
    let optionName = '';
    if (option) {
        optionName = safeToString(option.name);
    }
    return optionName;
}
function getCurrentlySelectedOption(options, selectedValue) {
    return options.find((option) => option.value === selectedValue);
}
//# sourceMappingURL=Dropdown.js.map