"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/** @jsx jsx */
const core_1 = require("@emotion/core");
const react_1 = require("react");
const selectionsOrchestrator_1 = require("../helpers/selectionsOrchestrator");
const Dropdown_1 = require("./Dropdown");
const getDependenciesKeyFrom_1 = require("../helpers/getDependenciesKeyFrom");
const NothingToSelect_1 = require("./NothingToSelect");
const dependenciesHelper_1 = require("../helpers/dependenciesHelper");
const canDisableClear_1 = require("../helpers/canDisableClear");
exports.SingleDropdown = (props) => {
    var _a;
    const [dropdownOptions, setDropdownOptions] = react_1.useState([]);
    const [dimension, setDimension] = react_1.useState();
    const onSelectChange = (selectedValue) => {
        props.onChange(selectedValue);
    };
    const cleanupSelections = () => {
        props.onChange(null);
    };
    const updateDepencenciesKey = () => {
        props.dependenciesKeyRef.current = getDependenciesKeyFrom_1.getDependenciesKeyFrom(props);
    };
    react_1.useEffect(() => {
        const updateSelections = () => __awaiter(void 0, void 0, void 0, function* () {
            try {
                const options = (yield selectionsOrchestrator_1.orchestrateSelections(props)) || {};
                const _dimension = Object.keys(options)[0];
                setDropdownOptions(options[_dimension]);
                setDimension(_dimension);
                if (dependenciesHelper_1.haveDependenciesChanged(props)) {
                    cleanupSelections();
                    updateDepencenciesKey();
                }
            }
            catch (e) {
                console.error('Error', e);
            }
        });
        updateSelections();
    }, [props.newDependenciesKey]);
    if (!dimension) {
        return core_1.jsx(NothingToSelect_1.NothingToSelect, { name: props.field.name });
    }
    return (core_1.jsx("div", { "data-testid": "SINGLE_DROPDOWN" },
        core_1.jsx(Dropdown_1.Dropdown, { key: dimension, disableClear: canDisableClear_1.canDisableClear(props), onSelectChange: onSelectChange, options: dropdownOptions, dimension: dimension, selectedValue: (_a = props.value, (_a !== null && _a !== void 0 ? _a : '')) })));
};
//# sourceMappingURL=SingleDropdown.js.map