"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/** @jsx jsx */
const core_1 = require("@emotion/core");
const sdk_1 = require("@builder.io/sdk");
const react_1 = __importStar(require("react"));
const mobx_react_1 = require("mobx-react");
const MultipleDropdowns_1 = require("./MultipleDropdowns");
const SingleDropdown_1 = require("./SingleDropdown");
const getDependenciesKeyFrom_1 = require("../helpers/getDependenciesKeyFrom");
exports.Component = mobx_react_1.observer((props) => {
    const { expectMultipleDropdowns } = props.field.options;
    const newDependenciesKey = getDependenciesKeyFrom_1.getDependenciesKeyFrom(props);
    const dependenciesKeyRef = react_1.useRef(newDependenciesKey);
    const targeting = props.context.designerState.editingContentModel.query
        .toJSON()
        .reduce((accum, q) => (Object.assign(Object.assign({}, accum), { [q.property]: q.value })), {});
    const newProps = Object.assign(Object.assign({}, props), { newDependenciesKey, targeting });
    if (expectMultipleDropdowns) {
        return core_1.jsx(MultipleDropdowns, Object.assign({}, newProps, { ref: dependenciesKeyRef }));
    }
    else {
        return core_1.jsx(SingleDropdown, Object.assign({}, newProps, { ref: dependenciesKeyRef }));
    }
});
const MultipleDropdowns = react_1.default.forwardRef((props, ref) => {
    return core_1.jsx(MultipleDropdowns_1.MultipleDropdowns, Object.assign({}, props, { dependenciesKeyRef: ref }));
});
const SingleDropdown = react_1.default.forwardRef((props, ref) => {
    return core_1.jsx(SingleDropdown_1.SingleDropdown, Object.assign({}, props, { dependenciesKeyRef: ref }));
});
sdk_1.Builder.registerEditor({
    name: 'dynamic-dropdown',
    component: exports.Component,
});
//# sourceMappingURL=index.js.map