"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mapperEvaluator_1 = require("./mapperEvaluator");
const selectionsClient_1 = require("./selectionsClient");
const dropdownPropsExtractor_1 = require("./dropdownPropsExtractor");
const selectionsCache = new Map();
const orchestrateSelections = (props) => __awaiter(void 0, void 0, void 0, function* () {
    let dropdownsOptions;
    let cacheKey;
    try {
        const { url, mapper } = dropdownPropsExtractor_1.getMassagedProps(props);
        cacheKey = `${url}-${mapper}`;
        if (selectionsCache.has(cacheKey))
            return selectionsCache.get(cacheKey);
        const data = yield selectionsClient_1.executeGet(url);
        dropdownsOptions = mapperEvaluator_1.safeEvaluate(mapper, { data });
    }
    catch (e) {
        console.error('orchestrateSelections Error: ', e);
    }
    if (!dropdownsOptions) {
        return {};
    }
    if (cacheKey) {
        selectionsCache.set(cacheKey, dropdownsOptions);
    }
    return dropdownsOptions;
});
exports.orchestrateSelections = orchestrateSelections;
//# sourceMappingURL=selectionsOrchestrator.js.map